#include "stdafx.h"
#include "testgetfile.h"
#include "testgetfileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CTestgetfileDlg::CTestgetfileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestgetfileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestgetfileDlg)
	m_bOldStyle = FALSE;
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  m_sFilename = _T("bla");
}

void CTestgetfileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestgetfileDlg)
	DDX_Control(pDX, IDC_OLD_STYLE, m_ctrlOldStyle);
	DDX_Control(pDX, IDC_OVERWRITE_PROMPT, m_ctrlOverwritePrompt);
	DDX_Control(pDX, IDC_FILE_MUST_EXIST, m_ctrlFileMustExist);
	DDX_Check(pDX, IDC_OLD_STYLE, m_bOldStyle);
	//}}AFX_DATA_MAP
  
  DWORD dwFlags = 0;
  if (m_ctrlOverwritePrompt.GetCheck())
    dwFlags |= GF_OVERWRITEPROMPT;
  if (m_ctrlFileMustExist.GetCheck())
    dwFlags |= GF_FILEMUSTEXIST;
  if (m_ctrlOldStyle.GetCheck())
    dwFlags |= GF_OLD_STYLE_DIALOG;

  DDX_FilenameControl(pDX, IDC_FILENAME, m_ctrlGetFilename, dwFlags, _T("Please specify a filename"), _T("All Files (*.*)|*.*||"));
  DDX_FilenameValue(pDX, m_ctrlGetFilename, m_sFilename);
  DDV_FilenameControl(pDX, m_ctrlGetFilename);
}

BEGIN_MESSAGE_MAP(CTestgetfileDlg, CDialog)
	//{{AFX_MSG_MAP(CTestgetfileDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FILE_MUST_EXIST, OnFileMustExist)
	ON_BN_CLICKED(IDC_OVERWRITE_PROMPT, OnOverwritePrompt)
	ON_BN_CLICKED(IDC_OLD_STYLE, OnOldStyle)
	ON_BN_CLICKED(IDC_READONLY, OnReadonly)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CTestgetfileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	return TRUE;
}

void CTestgetfileDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
		CDialog::OnPaint();
}

HCURSOR CTestgetfileDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestgetfileDlg::OnFileMustExist() 
{
  BOOL bMustExist;
  CDataExchange DX(this, TRUE);
	DDX_Check(&DX, IDC_FILE_MUST_EXIST, bMustExist);

  DWORD dwFlags = m_ctrlGetFilename.GetFlags();
  if (bMustExist)
    dwFlags |= GF_FILEMUSTEXIST;
  else
    dwFlags &= ~GF_FILEMUSTEXIST; 

  m_ctrlGetFilename.SetFlags(dwFlags);
}

void CTestgetfileDlg::OnOverwritePrompt() 
{
  BOOL bOverwritePrompt;
  CDataExchange DX(this, TRUE);
	DDX_Check(&DX, IDC_OVERWRITE_PROMPT, bOverwritePrompt);

  DWORD dwFlags = m_ctrlGetFilename.GetFlags();
  if (bOverwritePrompt)
    dwFlags |= GF_OVERWRITEPROMPT;
  else
    dwFlags &= ~GF_OVERWRITEPROMPT; 

  m_ctrlGetFilename.SetFlags(dwFlags);
}

void CTestgetfileDlg::OnOldStyle() 
{
  CDataExchange DX(this, TRUE);
  DDX_Check(&DX, IDC_OLD_STYLE, m_bOldStyle);

  DWORD dwFlags = m_ctrlGetFilename.GetFlags();
  if (m_bOldStyle)
    dwFlags |= GF_OLD_STYLE_DIALOG;
  else
    dwFlags &= ~GF_OLD_STYLE_DIALOG; 

  m_ctrlGetFilename.SetFlags(dwFlags);
}

void CTestgetfileDlg::OnReadonly() 
{
  CDataExchange DX(this, TRUE);
  BOOL bReadOnly;
  DDX_Check(&DX, IDC_READONLY, bReadOnly);
  m_ctrlGetFilename.SetReadOnly(bReadOnly);
}
